---
--- Generated by lvmm
--- DateTime: 2020-09-08
--- 图片-详情
---

local _class = {
    _name = 'AmwayImageDetail',
    _version = '1.0',
    _subViews = { }
}

---@public
function _class:new(ticket,game_id,url,article_id,role_id,cid)
    local o = {}
    setmetatable(o, {__index = self})
    self.ticket = ticket
    self.game_id = game_id
    self.webUrl = url
    self.article_id = article_id
    self.role_id = role_id
    self.share_url = ''
    self.cid = cid
    self.isVisiable = false
    self.startY = 0
    self.user_like = 0
    return o
end

---@public
---@return View containerView
function _class:rootView()
    self:loadExtensions()
    self.containerView = View():width(MeasurementType.MATCH_PARENT)
                            :height(MeasurementType.MATCH_PARENT):bgImage(_ImageRootRoute .. 'images/main_background.png')
    self:setupTabar()
    self:setupBottomAction()
    self:requestNetworkDetail()
    return self.containerView
end

---优先加载其他辅助文件
---@private
function _class:loadExtensions()
    require("../common/Constant")
end

---@private
function _class:setupTabar()
   
    local toolbar = LinearLayout(LinearType.HORIZONTAL)
                            :width(MeasurementType.MATCH_PARENT)
                            :height(40)

    if  self.cid ~= 'sdk_amway_video' then
        toolbar:bgColor(Color(0,0,0,0.3))
    end
                            
    local toolbarView = require('../common/ToolBar')
    toolbar:addView(toolbarView:setupToolbar())

    local webView = WebView():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):setGravity(Gravity.CENTER)
    
    if System:iOS() then
        self.containerView:addView(webView):addView(toolbar)
    else
        local nonVideoLayout = View():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)

        local videoLayout = LinearLayout():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
    
    
        nonVideoLayout:addView(webView)
    
        self.containerView:addView(nonVideoLayout):addView(toolbar):addView(videoLayout)
    
        VideoWebChromeClient:setWebView(nonVideoLayout,videoLayout,webView,function (isFullScreen)
            if isFullScreen then
                self.bottomContainer:hidden(true)
            else
                self.bottomContainer:hidden(false)
            end
        end)
    end

    if(self.webUrl) then
        if  self.cid == 'sdk_amway_wallpaper' then
            
            local html = "<html> \n"
                        .. "<head> \n"
                        .."<style type=\"text/css\"> \n"
                        .."body {font-size:15px;}\n"
                        .."</style> \n"
                        .."</head> \n"
                        .."<body>"
                        .."<script type='text/javascript'>"
                        .."window.onload = function(){\n"
                        .."var $img = document.getElementsByTagName('img');\n"
                        .."for(var p in  $img){\n"
                        .."}\n"
                        .."}"
                        .."</script>"
                        .."<div algin='center'>"
                        .."<img src='".. self.webUrl.."'/>"
                        .."</div>"
                        .."</body>"
                        .."</html>"
            webView:loadHtmlString(html)
        else
            webView:loadUrl(self.webUrl)
        end
       
    end

end

---@private
function _class:setupBottomAction()
    self.bottomContainer = View():width(MeasurementType.MATCH_PARENT):height(50):setGravity(Gravity.BOTTOM)
    
    
    
    local leftActionContainer = LinearLayout(LinearType.HORIZONTAL):width(85):height(32):cornerRadius(15)
                                        :setGravity(Gravity.CENTER):borderWidth(1):borderColor(Color(129,114,92,1)):marginRight(60)
    local rightActionContainer = LinearLayout(LinearType.HORIZONTAL):width(85):height(32):cornerRadius(15)
                                        :setGravity(Gravity.CENTER):borderWidth(1):borderColor(Color(129,114,92,1)):marginLeft(60)

    self.bottomContainer:addView(leftActionContainer):addView(rightActionContainer)

    self.likeImage = ImageView():width(20):height(20):image(_ImageRootRoute .. 'images/ic_article_detail_like.png'):setGravity(Gravity.CENTER):marginLeft(15)
    self.likeLable = Label():fontSize(12):textColor(ColorConstants.TextColorTheme):setGravity(Gravity.CENTER):marginLeft(12)
    leftActionContainer:addView(self.likeImage):addView(self.likeLable)

    local shareImage = ImageView():width(20):height(20):image(_ImageRootRoute .. 'images/ic_article_detail_share.png'):setGravity(Gravity.CENTER):marginLeft(15)
    local shareLable = Label():fontSize(11):textColor(ColorConstants.TextColorTheme):setGravity(Gravity.CENTER):marginLeft(12):text('分享')
    rightActionContainer:addView(shareImage):addView(shareLable)

    if  self.cid ~= 'sdk_amway_video' then
        self.bottomContainer:bgColor(Color(0,0,0,0.3))
        shareImage:image(_ImageRootRoute .. 'images/ic_amway_download.png')
        shareLable:text('下载')
    end

    leftActionContainer:onClick(function()
        -- 点击点赞
        self:requestNetworkLike()
    end)

    rightActionContainer:onClick(function()
        if  self.cid == 'sdk_amway_video' then
            -- 点击分享
            Clipboard:setText(self.share_url)
            Toast("链接已复制到您的粘贴版中，快去分享给您的小伙伴们吧～",2.0)
        else
            --点击下载
            self:saveImageToGallery()
        end
    end)

    self.containerView:addView(self.bottomContainer)
end

function _class:saveImageToGallery()
    -- body
    ImageUtil:saveImageToGallery(self.webUrl,function (code)
        if code == 1 then
            Toast('图片保存成功',2)
        elseif code == -1 then
            if System:iOS() then
                Toast('请在设置中开启相机权限',2)
            end
        else
            Toast('图片保存失败',2)
        end
    end)
end

-- 获取详情
function _class:requestNetworkDetail()
    local http = Http()

    local header = {}
    header['Ticket'] = self.ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['article_id'] = self.article_id
    params['game_id'] = self.game_id
 

    http:post(HttpContants.Root .. HttpContants.Http_Article_Detail,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data')
            
                if data then
                    self.likeLable:text(tostring(data:get('like_num')))
                    self.share_url = data:get('video_share_url')
                    self.user_like = data:get('user_like')
                    self:refreshLike()
                end
            else
            end
        else
          
        end
        _class.isRequesting = false
    end)    
end

function _class:refreshLike()
    -- body
    if self.user_like == 0 then
        --未点赞
        self.likeImage:image(_ImageRootRoute .. 'images/ic_article_detail_like.png')
    else
        --已点赞
        self.likeImage:image(_ImageRootRoute .. 'images/ic_lick_true.png')
    end
end

-- 点赞
function _class:requestNetworkLike()
    local http = Http()

    local header = {}
    header['Ticket'] = self.ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['article_id'] = self.article_id
    params['game_id'] = self.game_id
    if self.cid == 'sdk_amway_video' then
        params['type'] = '3'
    else
        params['type'] = '2'
    end
  
    if self.user_like == 0 then
        params['status'] = '1'
    else
        params['status'] = '0'
    end

    http:post(HttpContants.Root .. HttpContants.Http_Article_Like,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                self:requestNetworkDetail()
            else
                Toast(resp:get('msg'),2.0)
            end
        end
        _class.isRequesting = false
    end)    
end

---
--- Generated by lvmm
--- DateTime: 2020-09-08
--- 打开详情页
--- 参数:key  loadWebUrl String
---      key  article_id String
---      key  ticket String
---      key  gameid String
---      key  role_id String
---
--- 暂时设置为全局，避免被gc
local ticket = window:getExtra():get('ticket')
local gameid = window:getExtra():get('gameid')
local role_id = window:getExtra():get('role_id')
local url = window:getExtra():get('loadWebUrl')
local article_id = window:getExtra():get('article_id')
local cid = window:getExtra():get('cid')
mAmwayImageDetail = _class:new(ticket,gameid,url,article_id,role_id,cid)
window:addView(mAmwayImageDetail:rootView())

return _class

