---
--- Generated by lvmm
--- DateTime: 2020-08-26
--- 安利列表
---

local _class = {
    _name = 'AmwayListView',
    _version = '1.0',
    isRequesting = false
}

---@public
function _class:new(cid,Ticket,game_id,role_id,isSwitch)
    local o = {}
    setmetatable(o, {__index = self})
    self.dataList = Array()
    self.pageIndex = 1
    self.cid = cid
    self.Ticket = Ticket
    self.game_id = game_id
    self.role_id = role_id
    self.isSwitch = isSwitch
    self.isVideo = isVideo
     --2--最热 1--最新
    self.switchType = 2
    return o
end

---@public
---@return View containerView
function _class:rootView(cid)
    -- print('cid:'..self.cid)
    self.cid = cid
    if self.containerView then
        return self.containerView
    end
    self.containerView = LinearLayout(LinearType.VERTICAL)
    self.containerView:width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
    -- self.containerView:bgColor(ColorConstants.IntroToolBarTitlleNormal)
    if self.isSwitch then
        self.containerView:addView(self:setupSwitch())
    end

    if cid == 'sdk_amway_video' then
        self.isVideo = true
    else
        self.isVideo = false
    end

    self:initListView(self.isVideo)
    self:setupDataSource(true)
    return self.containerView
end

--绘制列表控件
function _class:initListView(isVideo)
    self.collectionView = WaterfallView(false, true)
                                :width(MeasurementType.MATCH_PARENT)
                                :height(MeasurementType.MATCH_PARENT)
                                :scrollDirection(ScrollDirection.VERTICAL)--竖直方向滑动
                                --:scrollDirection(ScrollDirection.HORIZONTAL)--水平方向滑动
                                :showScrollIndicator(true)--是否显示滑动指示器

    --layout
    local collectionLayout = WaterfallLayout()
    collectionLayout:lineSpacing(5)
    collectionLayout:itemSpacing(5)
    --竖直滑动代表显示列数；水平滑动代表显示行数
    collectionLayout:spanCount(3)
    --设置layout
    self.collectionView:layout(collectionLayout)

    self.collectionView:setLoadingCallback(function ()
        self:requestNetwork(false,function(success, data)
            self.collectionView:stopLoading()
            
            if not data or data:size() == 0 then
                self.collectionView:noMoreData()
            else
                if success then
                    self.collectionView:reloadData()
                end
            end
            
        end)
    end)

    --adapter
    self.adapter = WaterfallAdapter()

    self.adapter:sectionCount(function()
        return 1
    end)

    -----------------------------设置子view个数---------------------------------------
    self.adapter:rowCount(function(section)
        return self.dataList:size()
    end)
    ------------------------------设置cell宽高----------------------------------------
    --根据类型标识设置对应子view的高度

    self.adapter:heightForCell(function(_, row)
        if isVideo then
            return 170
        else
            return 130
        end
    end)
    -------------------------------子view类型-----------------------------------------
    --返回当前位置子view的类型标识
    self.adapter:reuseId(function(section, row)
        return "CellId"
    end)
    -------------------------------创建子view-----------------------------------------
    self.adapter:initCellByReuseId("CellId", function(cell)
        local internalCell = require("amway/AmwayCell"):new()
        internalCell:setupCellSubviews(isVideo)
        cell._cell = internalCell

        -- cell.contentView:bgColor(Color(75, 63, 55, 0.6))
        -- cell.contentView:cornerRadius(2)
        cell.contentView:addView(internalCell.containerView)
    end)
    --------------------------将子view与数据进行绑定赋值----------------------------------
    self.adapter:fillCellDataByReuseId("CellId", function(cell, section, row)
        --填充数据
        cell._cell:updateCell(self.cid,self.dataList:get(row))
    end)
    self.adapter:selectedRowByReuseId('CellId', function(cell, _, row)
    
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('article_id',self.dataList:get(row):get('article_id'))

        if self.cid == 'sdk_amway_diffuse' then
            params:put('cid',self.cid)
            params:put('loadWebUrl',self.dataList:get(row):get('content_img'))
            Navigator:gotoPageOri(NavigatorRoute.AmwayImageDetailRoute,params,1, AnimType.BottomToTop)
        elseif self.cid == 'sdk_amway_video' then
            params:put('loadWebUrl',self.dataList:get(row):get('video_detail'))
            params:put('cid',self.cid)
            Navigator:gotoPageOri(NavigatorRoute.AmwayImageDetailRoute,params,3, AnimType.BottomToTop)
        else
            params:put('cid',self.cid)
            params:put('loadWebUrl',self.dataList:get(row):get('content_img'))
            Navigator:gotoPageOri(NavigatorRoute.AmwayImageDetailRoute,params,3, AnimType.BottomToTop)
        end
    end)

    self.collectionView:adapter(self.adapter)
    
    self.containerView:addView(self.collectionView)

end

function _class:setupSwitch()
    -- body
    local switchView = LinearLayout(LinearType.HORIZONTAL):width(85):height(20):marginTop(4):marginBottom(4):cornerRadius(10)
                            :bgColor(Color(41,38,44,1)):borderWidth(1):borderColor(Color(255, 255, 255, 0.06)):setGravity(Gravity.RIGHT)
    self.hotLabel = Label():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                        :weight(1):cornerRadius(10):text('最热'):textAlign(TextAlign.CENTER)
    self.newLabel = Label():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                        :weight(1):cornerRadius(10):text('最新'):textAlign(TextAlign.CENTER)
    switchView:addView(self.hotLabel):addView(self.newLabel)
    self:switch()

    self.hotLabel:onClick(function()
        if self.switchType == 1 then
            self.pageIndex = 1
            self.switchType = 2
            self:setupDataSource(true)
            self:switch()
        end
    end)

    self.newLabel:onClick(function()
        if self.switchType == 2 then
            self.pageIndex = 1
            self.switchType = 1
            self:setupDataSource(true)
            self:switch()
        end
    end)

    return switchView
end

function _class:switch()
    -- body
    if self.switchType == 2 then
        self.hotLabel:bgColor(Color(92,74,59,0.7)):textColor(Color(177,162,138,1))
        self.newLabel:bgColor(Color(92,74,59,0)):textColor(Color(123,123,123,1))
    else
        self.hotLabel:bgColor(Color(92,74,59,0)):textColor(Color(123,123,123,1))
        self.newLabel:bgColor(Color(92,74,59,0.7)):textColor(Color(177,162,138,1))
    end
end

---请求接口
---@private
function _class:requestNetwork(first, complete)
    if not self.isRequesting then
        self.isRequesting = true
        local http = Http()

        local header = {}
        
        header['Ticket'] = self.Ticket
        header['gameid'] = self.game_id
        header['roleid'] = self.role_id

        local params = {}
        params['cid'] = self.cid
        params['game_id'] = self.game_id
        params['page'] = self.pageIndex
        params['page_size'] = '10'
        params['sort_type'] = self.switchType

        http:post(HttpContants.Root .. HttpContants.Http_Page_Strategy,params,header,function(success, resp, error)
        
            if success and resp then
                if(resp:get('code') == 0) then
                    local data = resp:get('data'):get('data')
                    if first then
                        self.dataList = data
                    elseif data then
                        self.dataList:addAll(data)
                    end
                    complete(true, data)
                    self.pageIndex = self.pageIndex + 1
                else
                end
            else
          
            end
            self.isRequesting = false
        end)
        end
end

--加载数据
function _class:setupDataSource(isFirst)
    self:requestNetwork(isFirst, function(success, _)
        if success then
            if self.dataList:size() > 0 then
                self.collectionView:reloadData()
            end
        end
    end)
end

return _class