---
--- Generated by lvmm
--- DateTime: 2020-08-06
--- 玩法tabbar
---

local _class = {
    _name = 'IntroPlayTabToolBar',
    _version = '1.0'
}

---@public
function _class:new()
    local o = {}
    setmetatable(o, { __index = self })
    return o
end

---@public
function _class:setupItems(titles,callback)
    self.clickCallback = callback
    self:createBarButtonItems(titles)
end

---@private
function _class:createBarButtonItems(titles)
    
    local itemCount = titles:size()

    local tabToolBarHeight = 25

    self.contentView = View()
            :width(MeasurementType.MATCH_PARENT):height(tabToolBarHeight):priority(1)
    
    self.tabToolBar = LinearLayout(LinearType.HORIZONTAL)
    self.tabToolBar:width(MeasurementType.MATCH_PARENT):height(tabToolBarHeight)

    for i = 1, itemCount do
        local itemView = LinearLayout(LinearType.VERTICAL)
                                    :width(MeasurementType.MATCH_PARENT)
                                    :height(MeasurementType.MATCH_PARENT)
                                    :weight(1)
                                    :setGravity(Gravity.CENTER)

        local titleLabel = Label():width(MeasurementType.WRAP_CONTENT)
                                  :height(MeasurementType.WRAP_CONTENT)
                                  :setGravity(Gravity.CENTER)
                                  :marginTop(3)
                                  :fontSize(12)
        local titleBar = View():width(50):height(1):marginTop(5):setGravity(Gravity.CENTER)
      
        itemView:onClick(function()
            self:updateBarItemImages(titleLabel,titleBar,i)
            self.clickCallback(i)
        end)
        if i == 1 then
            self.preIndex = 1
            self.preTitle = titleLabel
            self.titleBar = titleBar
            titleLabel:textColor(Color(255,248,222,1))
            titleBar:bgColor(Color(255,248,222,1))
        else
            titleLabel:textColor(Color(123,123,123,1))
            titleBar:bgColor(Color(255,248,222,0))
        end

        titleLabel:text(titles:get(i))
        itemView:addView(titleLabel):addView(titleBar)
       
        self.tabToolBar:addView(itemView)
    end

    self.contentView:addView(self.tabToolBar)
end

function _class:updateBarItemImages(titleLabel,titleBar, index)
    if index == self.preIndex then
        return --点击同一个barItem不更新image
    end

    self.titleBar:bgColor(Color(255,248,222,0))
    titleBar:bgColor(Color(255,248,222,1))

    self.preTitle:textColor(Color(123,123,123,1))
    titleLabel:textColor(Color(255,248,222,1))

    self.titleBar = titleBar
    self.preTitle = titleLabel
    self.preIndex = index
end

return _class