---
--- Generated by lvmm
--- DateTime: 2020-08-06
---

local _class = {
    _name = 'IntroTabToolBar',
    _version = '1.0'
}

---@public
function _class:new()
    local o = {}
    setmetatable(o, { __index = self })
    return o
end

---@public
--- callback function
function _class:setupItems(containerImage,normalImages, selectImages, titles,normalTitleColor,selectTitleColor,callback)
    self.clickCallback = callback
    self:createBarButtonItems(containerImage,normalImages, selectImages,titles,normalTitleColor,selectTitleColor)
end

---@private
function _class:createBarButtonItems(containerImage, normalImages, selectImages, titles, normalTitleColor, selectTitleColor)
    if normalImages:size() ~= selectImages:size() then
        return
    end
    self.normalImages = normalImages
    self.selectImages = selectImages
    self.normalTitleColor = normalTitleColor
    self.selectTitleColor = selectTitleColor
    local itemCount = normalImages:size()

    local tabToolBarHeight = 35

    self.contentView = View()
            :width(MeasurementType.MATCH_PARENT):height(tabToolBarHeight):priority(1):bgImage(containerImage)
    
    self.tabToolBar = LinearLayout(LinearType.HORIZONTAL)
    self.tabToolBar:width(MeasurementType.MATCH_PARENT):height(tabToolBarHeight)

    for i = 1, itemCount do
        local itemView = View(LinearType.VERTICAL)
                                    :width(MeasurementType.MATCH_PARENT)
                                    :height(MeasurementType.MATCH_PARENT)
                                    :weight(1)
                                    :marginTop(2)
                                    :marginBottom(2)
                                    :marginLeft(2)
                                    :marginRight(2)
                                    :setGravity(Gravity.CENTER)

        local titleLabel = Label():width(MeasurementType.WRAP_CONTENT)
                                  :height(MeasurementType.WRAP_CONTENT)
                                  :setGravity(Gravity.CENTER)
      
        -- image
        itemView:onClick(function()
            self:updateBarItemImages(itemView,titleLabel,i)
            self.clickCallback(i)
        end)
        if i == 1 then
            self.preIndex = 1
            self.preItemView = itemView
            self.preTitle = titleLabel
            itemView:bgImage(selectImages:get(1))
            titleLabel:textColor(selectTitleColor)
        else
            itemView:bgImage(normalImages:get(i))
            titleLabel:textColor(normalTitleColor)
        end

        titleLabel:text(titles:get(i))
        itemView:addView(titleLabel)
       
        self.tabToolBar:addView(itemView)
    end

    self.contentView:addView(self.tabToolBar)
end

function _class:updateBarItemImages(itemView, titleLabel, index)
    if index == self.preIndex then
        return --点击同一个barItem不更新image
    end
    self.preItemView:bgImage(self.normalImages:get(self.preIndex))
    itemView:bgImage(self.selectImages:get(index))
   

    self.preTitle:textColor(self.normalTitleColor)
    titleLabel:textColor(self.selectTitleColor)

    self.preItemView = itemView
    self.preTitle = titleLabel
    self.preIndex = index
end

return _class