local _class = {
    _name = "TabContainerView",
    _version = "1.0",
    _subViews = { },
    _subViewNames = { 'intro/IntroductionPagerView', --攻略页面
                      'master/MasterPagerView', --大神主页
                      'amway/AmwayPagerView', --安利主页
                      'mine/MinePagerView' --我的
                    },
}

---入口
---@public
function _class:setup(Ticket,game_id,role_id,role_name,role_avatar,role_level)
    self.Ticket = Ticket
    self.game_id = game_id
    self.role_id = role_id
    self.role_name = role_name
    self.role_avatar = role_avatar
    self.role_level = role_level

    if not self.Ticket then
        Toast('获取数据异常，重新打开看看~')
    end
    self:loadExtensions()
    self:setupContainerView()
    self:setupTabar()
end

---优先加载其他辅助文件
---@private
function _class:loadExtensions()
    require("common/Constant")
end

---布局view
---@private
function _class:setupContainerView()
    local containerView = LinearLayout(LinearType.HORIZONTAL)
                            :width(MeasurementType.MATCH_PARENT)
                            :height(MeasurementType.MATCH_PARENT)
                            :bgImage(_ImageRootRoute .. 'images/main_background.png')
            
    self.containerView = containerView

    window:addView(containerView)

    self.toolbar = LinearLayout(LinearType.VERTICAL)
                            :width(MeasurementType.WRAP_CONTENT)
                            :height(MeasurementType.MATCH_PARENT)
                            
    local toolbarView = require('common/ToolBar')
    self.toolbar:addView(toolbarView:setupToolbar())
    
    containerView:addView(self.toolbar)


    --展示内容
    local contentView = LinearLayout(LinearType.HORIZONTAL)
                            :width(MeasurementType.MATCH_PARENT)
                            :height(MeasurementType.MATCH_PARENT)
    self.contentView = contentView
    containerView:addView(contentView)
    
end

function _class:setupTabar()
    local normalImages = Array()
    normalImages:add(_ImageRootRoute .. "images/ic_tab_gl_icon_normal.png")
    normalImages:add(_ImageRootRoute .. "images/ic_tab_ds_icon_normal.png")
    normalImages:add(_ImageRootRoute .. "images/ic_tab_amway_icon_normal.png")
    -- normalImages:add(_ImageRootRoute .. "images/ic_tab_bk_icon_normal.png")
    normalImages:add(_ImageRootRoute .. "images/ic_tab_mine_icon_normal.png")

    local selectImages = Array()
    selectImages:add(_ImageRootRoute .. "images/ic_tab_gl_icon_focus.png")
    selectImages:add(_ImageRootRoute .. "images/ic_tab_ds_icon_focus.png")
    selectImages:add(_ImageRootRoute .. "images/ic_tab_amway_icon_focus.png")
    -- selectImages:add(_ImageRootRoute .. "images/ic_tab_bk_icon_focus.png")
    selectImages:add(_ImageRootRoute .. "images/ic_tab_mine_icon_focus.png")

    local normalBackImages = Array()
    normalBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")
    normalBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")
    normalBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")
    -- normalBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")
    normalBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")

    local selectBackImages = Array()
    selectBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_foucs.png")
    selectBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_foucs.png")
    selectBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_foucs.png")
    -- selectBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_foucs.png")
    selectBackImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_foucs.png")

    local titles = Array()
    titles:add('攻略')
    titles:add('大神')
    titles:add('安利')
    -- titles:add('百科')
    titles:add('我的')

    self.tabbar = require('common/TabToolBar'):new()
    self.tabbar:setupItems(normalImages, selectImages,normalBackImages,selectBackImages,titles,ColorConstants.TabBarLabelNormal,ColorConstants.TabBarLabelSelect, function(idx)
        -- if idx == 4 then
        --     Navigator:closeSelf(AnimType.TopToBottom)
        --     GlobalEvent:postEvent(GlobalCallbackKeyConstants.Baike,Map())
        -- else
        --     self:display(idx)
        -- end

        self:display(idx)
    end)
    self.toolbar:addView(self.tabbar.contentView)

     --默认展示第一页
     self:display(1)
end

---展示View逻辑
---@private
function _class:display(index)
    if self.prevSelectedView then
        self.prevSelectedView:rootView():removeFromSuper()
    end
    self.prevSelectedView = self._subViews[index]

    if not self.prevSelectedView then
        self.prevSelectedView = require(self._subViewNames[index]):new(self.Ticket,self.game_id,self.role_id,self.role_name,self.role_level,self.role_avatar)
        self._subViews[index] = self.prevSelectedView
    end
    self.contentView:addView(self.prevSelectedView:rootView())
end

return _class


