---
--- Generated by lvmm
--- DateTime: 2020-02-02
---

--攻略列表cell
local _class = {
    _name = "IntroCell",
    _version = "1.0"
}

---@public
function _class:new()
    local o = {}
    setmetatable(o, { __index = self })
    return o
end

---@public
function _class:setupCellSubviews()

    self.containerView = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT)
    --图片
    self.imageView = ImageView():width(160):height(73)
                                     :cornerRadius(3)
                                     :marginLeft(10)
                                     :marginTop(10)
                                     :priority(1)
                                     :contentMode(ContentMode.SCALE_TO_FILL)

    --右容器
    local rightContent = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT)
                                                             :height(MeasurementType.MATCH_PARENT)
                                                             :marginLeft(10)
                                                             :marginTop(10)
                                                             :marginRight(10)

    --title
    self.title = Label():fontSize(12)
                        :textColor(Color(219,188,138,1))
    rightContent:addView(self.title)

    --标签列表视图
    self:setupTapListView():marginTop(17)
    
    self.tapTableView:adapter(self.tapAdapter)
    rightContent:addView(self.tapTableView)

    --bottom
    local bottomContainer = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT)
                                                             :height(MeasurementType.WRAP_CONTENT)
                                                             :marginTop(15)
                                                             :marginRight(10)
                                                             
    --nickname
    self.nickname = Label():fontSize(10)
                        :textColor(Color(123,123,123,1))
                        :setGravity(Gravity.LEFT)
    --time
    self.time = Label():fontSize(10)
                        :textColor(Color(95,95,95,1))
                        :weight(1)
                        :setGravity(Gravity.LEFT)
                        :marginLeft(10)

    bottomContainer:addView(self.nickname):addView(self.time)
    rightContent:addView(bottomContainer)

    --action
    local actionContainer = LinearLayout(LinearType.HORIZONTAL)
    local seeImage = ImageView():width(15):height(9):image(_ImageRootRoute ..'images/ic_article_item_see.png')
    local likeImage = ImageView():width(10):height(10):image(_ImageRootRoute ..'images/ic_article_item_like.png'):marginLeft(20)
    self.seeLabel = Label():fontSize(10):textColor(Color(123,123,123,1)):marginLeft(5)
    self.likeLabel = Label():fontSize(10):textColor(Color(123,123,123,1)):marginLeft(5)

    actionContainer:addView(seeImage):addView(self.seeLabel):addView(likeImage):addView(self.likeLabel)
    bottomContainer:addView(actionContainer)

    --添加显示
    self.containerView:addView(self.imageView):addView(rightContent)
end


function _class:setupTapListView()
    self.tapTableView = CollectionView(false, false):width(250):height(16):scrollDirection(ScrollDirection.HORIZONTAL):enabled(false)
    self.tapLayout = CollectionViewGridLayout():itemSpacing(12):spanCount(1)
    self.tapAdapter = CollectionViewAutoFitAdapter()
    self.tagsArray = Array()
    self.tapAdapter:initCell(function(cell)
        cell.tapLabel = Label():textColor(Color(123,123,123,1))
                               :fontSize(10)
                               :bgColor(Color(41,38,44,1))
                               :padding(2,7,3,7)
                               :cornerRadius(7.5)
                               :borderWidth(1)
                               :borderColor(Color(109, 109, 109, 0.24))
                               
        cell.contentView:addView(cell.tapLabel)
        
    end)

    self.tapAdapter:fillCellData(function(cell, _, row)
        local item = self.tagsArray:get(row)
        cell.tapLabel:text(item)
    end)

    self.tapAdapter:rowCount(function()
        return self.tagsArray:size()
    end)

    self.tapTableView:layout(self.tapLayout)

    return self.tapTableView
end
---@public
---@param count string
function _class:updateCell(item)
    if not item then
        return
    end
    self.imageView:image(item:get('cover_img'))
    self.title:text(item:get('title'))
    self.nickname:text(item:get('god_nickname'))
    self.time:text(item:get('release_time'))
    self.seeLabel:text(item:get('view_num'))
    self.likeLabel:text(item:get('like_num'))
    self.tagsArray = item:get('tags')
end

---@public
---@vararg string 图标urlString
function _class:updateContentIcons(url)
    -- local iconView = self.iconViews[1]
    -- if url then
    --     iconView:gone(false)
    --     iconView:image(url)
    -- else
    --     iconView:gone(true)
    -- end
end

return _class