---
--- Generated by lvmm
--- DateTime: 2020-08-08
--- 攻略页面-详情
---

local _class = {
    _name = 'IntroDetail',
    _version = '1.0',
    _subViews = { }
}

---@public
function _class:new(ticket,game_id,url,article_id,role_id)
    local o = {}
    setmetatable(o, {__index = self})
    self.ticket = ticket
    self.game_id = game_id
    self.webUrl = url
    self.article_id = article_id
    self.role_id = role_id
    self.share_url = ''
    self.user_like = 0
    return o
end

---@public
---@return View containerView
function _class:rootView()
    self:loadExtensions()
    self.containerView = View():width(MeasurementType.MATCH_PARENT)
                            :height(MeasurementType.MATCH_PARENT):bgImage(_ImageRootRoute .. 'images/main_background.png')
    self:setupTabar()
    self:setupBottomAction()
    self:requestNetworkDetail()
    return self.containerView
end

---优先加载其他辅助文件
---@private
function _class:loadExtensions()
    require("../common/Constant")
end

---@private
function _class:setupTabar()
   
    local toolbar = LinearLayout(LinearType.HORIZONTAL)
                            :width(MeasurementType.MATCH_PARENT)
                            :height(40)
                            
    local toolbarView = require('../common/ToolBar')
    toolbar:addView(toolbarView:setupToolbar())

    local webView = WebView():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):marginTop(40)

    if System:iOS() then
        self.containerView:addView(webView):addView(toolbar)
    else
        local nonVideoLayout = View():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
        local videoLayout = LinearLayout():width(MeasurementType.MATCH_PARENT):hidden(true)
                                :height(MeasurementType.MATCH_PARENT):bgColor(Color(0,0,0,1))
    
        nonVideoLayout:addView(webView)
    
        self.containerView:addView(nonVideoLayout):addView(toolbar):addView(videoLayout)
    
        VideoWebChromeClient:setWebView(nonVideoLayout,videoLayout,webView,function (isFullScreen)
            if isFullScreen then
                self.bottomContainer:hidden(true)
            else
                self.bottomContainer:hidden(false)
            end
        end)
    end

    if(self.webUrl) then
        webView:loadUrl(self.webUrl)
    end

end

---@private
function _class:setupBottomAction()
    self.bottomContainer = View():width(MeasurementType.MATCH_PARENT):height(32):marginBottom(20):setGravity(Gravity.BOTTOM)
    local leftActionContainer = LinearLayout(LinearType.HORIZONTAL):width(85):height(MeasurementType.MATCH_PARENT):cornerRadius(15)
                                        :setGravity(Gravity.CENTER):borderWidth(1):borderColor(Color(129,114,92,1)):marginRight(60)
    local rightActionContainer = LinearLayout(LinearType.HORIZONTAL):width(85):height(MeasurementType.MATCH_PARENT):cornerRadius(15)
                                        :setGravity(Gravity.CENTER):borderWidth(1):borderColor(Color(129,114,92,1)):marginLeft(60)

    self.bottomContainer:addView(leftActionContainer):addView(rightActionContainer)

    self.likeImage = ImageView():width(20):height(20):image(_ImageRootRoute .. 'images/ic_article_detail_like.png'):setGravity(Gravity.CENTER):marginLeft(15)
    self.likeLable = Label():fontSize(10):textColor(Color(129,114,92,1)):setGravity(Gravity.CENTER):marginLeft(12)
    leftActionContainer:addView(self.likeImage):addView(self.likeLable)

    local shareImage = ImageView():width(20):height(20):image(_ImageRootRoute .. 'images/ic_article_detail_share.png'):setGravity(Gravity.CENTER):marginLeft(15)
    local shareLable = Label():fontSize(10):textColor(Color(129,114,92,1)):setGravity(Gravity.CENTER):marginLeft(12):text('分享')
    rightActionContainer:addView(shareImage):addView(shareLable)

    leftActionContainer:onClick(function()
        -- 点击点赞
        self:requestNetworkLike()
    end)

    rightActionContainer:onClick(function()
        -- 点击分享
        Clipboard:setText(self.share_url)
        Toast("链接已复制到您的粘贴版中，快去分享给您的小伙伴们吧～",2.0)
    end)

    self.containerView:addView(self.bottomContainer)
end

function _class:refreshLike()
    -- body
    if self.user_like == 0 then
        --未点赞
        self.likeImage:image(_ImageRootRoute .. 'images/ic_article_detail_like.png')
    else
        --已点赞
        self.likeImage:image(_ImageRootRoute .. 'images/ic_lick_true.png')
    end
end

-- 获取详情
function _class:requestNetworkDetail()
    local http = Http()

    local header = {}
    header['Ticket'] = self.ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['article_id'] = self.article_id
    params['game_id'] = self.game_id

    http:post(HttpContants.Root .. HttpContants.Http_Article_Detail,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data')
            
                if data then
                    
                    self.likeLable:text(tostring(data:get('like_num')))
                    self.share_url = data:get('article_share_url')
                    self.user_like = data:get('user_like')
                    self:refreshLike()
                end
            else
            end
        else
          
        end
    end)    
end

-- 点赞
function _class:requestNetworkLike()
    local http = Http()

    local header = {}
    header['Ticket'] = self.ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['article_id'] = self.article_id
    params['game_id'] = self.game_id
    params['type'] = '1'
    if self.user_like == 0 then
        params['status'] = '1'
    else
        params['status'] = '0'
    end

    http:post(HttpContants.Root .. HttpContants.Http_Article_Like,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                self:requestNetworkDetail()
            else
                Toast(resp:get('msg'),2.0)
            end
        end
    end)    
end

return _class