---
--- Generated by lvmm
--- DateTime: 2020-08-06
--- 攻略页面
---

local _class = {
    _name = 'IntroductionPagerView',
    _version = '1.0',
    _subViews = { },
    _subViewNames = { 'intro/IntroListView', --新手攻略
                      'intro/IntroListView', --进阶攻略
                      'intro/IntroductionPlay' --玩法
                    },
    _subCid = {
        'sdk_new_strategy',
        'sdk_advance_strategy',
        '',
    }
}

---@public
function _class:new(Ticket,game_id,role_id)
    local o = {}
    setmetatable(o, {__index = self})
    self.Ticket = Ticket
    self.game_id = game_id
    self.role_id = role_id
    return o
end

---@public
---@return View containerView
function _class:rootView()
    if self.containerView then
        return self.containerView
    end
    self.containerView = LinearLayout(LinearType.VERTICAL)
    self.containerView:width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):marginLeft(10):marginRight(10)
    
    local searchContainer = View():width(MeasurementType.MATCH_PARENT)
                                :height(35)
                                :bgColor(Color(66,66,66,0.15))
                                :borderWidth(1.5)
                                :borderColor(Color(38, 38, 38, 0.82))
                                :cornerRadius(3):marginTop(3)
                                :marginBottom(3)

    local searchLabel = Label():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                            :bgColor(Color(0,0,0,1)):textColor(Color(74,73,73,1)):fontSize(12):text('  输入关键字搜索攻略')
                            :marginLeft(1):marginRight(1):marginTop(1):marginBottom(1)
    local searchImage = ImageView():width(14):height(14):image(_ImageRootRoute .. 'images/search_button.png'):setGravity(Gravity.RIGHT):marginRight(12):marginTop(9)
    searchContainer:addView(searchLabel):addView(searchImage)

    searchContainer:onClick(function ()
        --进入搜索页面
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('game_id',self.game_id)
        params:put('role_id',self.role_id)
        Navigator:gotoPageOri(NavigatorRoute.SearchViewRoute,params,3, AnimType.BottomToTop)
    end)

    self.containerView:addView(searchContainer)
    self:setupTabar()
    return self.containerView
end

---@private
function _class:setupTabar()
    local normalImages = Array()
    normalImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")
    normalImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")
    normalImages:add(_ImageRootRoute .. "images/image_tab_gl_bg_normal.png")

    local selectImages = Array()
    selectImages:add(_ImageRootRoute .. "images/image_intr_tablayout_selected.png")
    selectImages:add(_ImageRootRoute .. "images/image_intr_tablayout_selected.png")
    selectImages:add(_ImageRootRoute .. "images/image_intr_tablayout_selected.png")

    local titles = Array()
    titles:add('新手攻略')
    titles:add('进阶攻略')
    titles:add('玩法')

    local back = _ImageRootRoute .. 'images/image_intr_tablayout_back.png'

    self.tabbar = require('common/IntroTabToolBar'):new()
    self.tabbar:setupItems(back,normalImages, selectImages,titles,ColorConstants.IntroToolBarTitlleNormal,ColorConstants.IntroToolBarTitlleSelected, function(idx)
        self:display(idx)
    end)
    self.containerView:addView(self.tabbar.contentView)

    --默认展示第一页
    self:display(1)
end

---展示View逻辑
---@private
function _class:display(index)
    if self.prevSelectedView then
        self.prevSelectedView:rootView(self._subCid[index]):removeFromSuper()
    end
    self.prevSelectedView = self._subViews[index]

    if not self.prevSelectedView then
        self.prevSelectedView = require(self._subViewNames[index]):new(self._subCid[index],self.Ticket,self.game_id,self.role_id,true)
        self._subViews[index] = self.prevSelectedView
    end
    self.containerView:addView(self.prevSelectedView:rootView(self._subCid[index]))
end

return _class