---
--- Generated by lvmm
--- DateTime: 2020-08-09
--- 搜索页面
---

local _class = {
    _name = 'SearchView',
    _version = '1.0',
    _subViews = { }
}

---@public
function _class:new(Ticket,game_id,role_id)
    local o = {}
    setmetatable(o, {__index = self})
    self.dataList = Array()
    self.Ticket = Ticket
    self.game_id = game_id
    self.role_id = role_id
    self.pageIndex = 1
    self.search = ''
    return o
end

---@public
---@return View containerView
function _class:rootView()
    self:loadExtensions()
    self.containerView = View():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                                :bgImage(_ImageRootRoute .. 'images/main_background.png')
    self:setupTabar()
    self:setupContentView()
    return self.containerView
end

---优先加载其他辅助文件
---@private
function _class:loadExtensions()
    require("../common/Constant")
end

---@private
function _class:setupTabar()
   
    local toolbar = LinearLayout(LinearType.HORIZONTAL)
                            :width(MeasurementType.MATCH_PARENT)
                            :height(40)
                            
    local toolbarView = require('../common/ToolBar')
    toolbar:addView(toolbarView:setupToolbar())

    self.searchContainer = View():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):marginLeft(10):marginRight(13)
                                :bgColor(Color(66,66,66,0.15)):borderWidth(1.5):borderColor(Color(38, 38, 38, 0.82)):cornerRadius(3):marginTop(3):marginBottom(3)

    local searchLabel = EditTextView():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                            :bgColor(Color(0,0,0,1)):placeholderColor(Color(74,73,73,1)):fontSize(12):placeholder('  输入关键字搜索攻略')
                            :marginLeft(1):marginRight(1):marginTop(1):marginBottom(1)
                            :returnMode(ReturnType.Search):singleLine(true):textColor(Color(255,255,255,1))
    local searchImage = ImageView():width(14):height(14)
                                :image(_ImageRootRoute .. 'images/search_button.png'):setGravity(Gravity.RIGHT):marginRight(12):marginTop(9)
    self.searchContainer:addView(searchLabel):addView(searchImage)

    toolbar:addView(self.searchContainer)

    self.containerView:addView(toolbar)

    searchLabel:setReturnCallback(function ()
        -- return search
        searchLabel:dismissKeyboard()
        self.search = searchLabel:text()
        if self.search then
            self.pageIndex = 1
            self.searchHint:text('“'..self.search..'”相关的内容如下：')
            self.lineImage:hidden(false)
            self:requestNetwork(true,function (success, _)
                if self.dataList:size() > 0 then
                    self.collectionView:reloadData()
                end
            end)
        else
            Toast('请输入关键字',2.0)
        end
    end)
end

function _class:setupContentView()
    -- body
    local contentView = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                            :marginTop(58):marginLeft(20):marginRight(20)
                            
    self.containerView:addView(contentView)

    self.searchHint = Label():fontSize(10):textColor(Color(177,162,138,1)):text(''):marginBottom(7)
    self.lineImage = ImageView():width(MeasurementType.MATCH_PARENT):height(2)
                            :contentMode(ContentMode.SCALE_TO_FILL):image(_ImageRootRoute .. 'images/image_master_user_line.png')
                            :hidden(true)
    
    contentView:addView(self.searchHint):addView(self.lineImage):addView(self:setupListView())
end

function _class:setupListView()
    -- body
     self.collectionView = WaterfallView(false, true)
                                :width(MeasurementType.MATCH_PARENT)
                                :height(MeasurementType.MATCH_PARENT)
                                :scrollDirection(ScrollDirection.VERTICAL)--竖直方向滑动
                                --:scrollDirection(ScrollDirection.HORIZONTAL)--水平方向滑动
                                :showScrollIndicator(true)--是否显示滑动指示器

    --layout
    local collectionLayout = WaterfallLayout()
    collectionLayout:lineSpacing(5)
    --竖直滑动代表显示列数；水平滑动代表显示行数
    collectionLayout:spanCount(1)
    --设置layout
    self.collectionView:layout(collectionLayout)

    self.collectionView:setLoadingCallback(function ()
        self:requestNetwork(false,function(success, data)
            self.collectionView:stopLoading()
            
            if not data or data:size() == 0 then
                self.collectionView:noMoreData()
            else
                if success then
                    self.collectionView:reloadData()
                end
            end
        end)
    end)

    --adapter
    self.adapter = WaterfallAdapter()

    self.adapter:sectionCount(function()
        return 1
    end)

    -----------------------------设置子view个数---------------------------------------
    self.adapter:rowCount(function(section)
        return self.dataList:size()
    end)
    ------------------------------设置cell宽高----------------------------------------
    --根据类型标识设置对应子view的宽高
    self.adapter:heightForCell(function(_, row)
        return 92
    end)
    -------------------------------子view类型-----------------------------------------
    --返回当前位置子view的类型标识
    self.adapter:reuseId(function(section, row)
        return "CellId"
    end)
    -------------------------------创建子view-----------------------------------------
    self.adapter:initCellByReuseId("CellId", function(cell)
        local internalCell = require("IntroCell"):new()
        internalCell:setupCellSubviews()
        cell._cell = internalCell

        cell.contentView:bgColor(ColorConstants.IntroCellBackColor)
        cell.contentView:cornerRadius(2)
        cell.contentView:addView(internalCell.containerView)
    end)
    --------------------------将子view与数据进行绑定赋值----------------------------------
    self.adapter:fillCellDataByReuseId("CellId", function(cell, section, row)
        --填充数据
        cell._cell:updateCell(self.dataList:get(row))
    end)
    self.adapter:selectedRowByReuseId('CellId', function(cell, _, row)
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('loadWebUrl',self.dataList:get(row):get('article_detail_url'))
        params:put('article_id',self.dataList:get(row):get('article_id'))
        Navigator:gotoPageOri(NavigatorRoute.IntroDetailViewRoute,params,3, AnimType.BottomToTop)
    end)

    self.collectionView:adapter(self.adapter)
    
    return self.collectionView
end

---请求接口
---@private
function _class:requestNetwork(first, complete)
    
    

    local http = Http()

    local header = {}
    header['Ticket'] = self.Ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['search'] = self.search
    params['game_id'] = self.game_id
    params['page'] = self.pageIndex
    params['page_size'] = '10'
    params['sort_type'] = '2'

    http:post(HttpContants.Root .. HttpContants.Http_Article_Search,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data'):get('data')
                if first then
                    self.dataList = data
                elseif data then
                    self.dataList:addAll(data)
                end
                complete(true, data)
                self.pageIndex = self.pageIndex + 1
            else
            end
        else
        end
    end)

end

local Ticket = window:getExtra():get('ticket')
local game_id = window:getExtra():get('game_id')
local role_id = window:getExtra():get('role_id')
_class:new(Ticket,game_id,role_id)
window:addView(_class:rootView())
return _class

