---
--- Generated by lvmm
--- DateTime: 2020-08-08
--- 攻略页面-详情
---

local _class = {
    _name = 'MasterDetail',
    _version = '1.0',
    _subViews = { }
}

---@public
function _class:new(ticket,game_id,user_id,role_id)
    local o = {}
    setmetatable(o, {__index = self})
    self.dataList = Array()
    self.ticket = ticket
    self.game_id = game_id
    self.user_id = user_id
    self.role_id = role_id
    self.pageIndex = 1
    return o
end

---@public
---@return View containerView
function _class:rootView()
    self:loadExtensions()
    self.containerView = LinearLayout(LinearType.VERTICAL)
                            :width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
                            :bgImage(_ImageRootRoute .. 'images/main_background.png')
    self:setupTabar()
    self:setupCollectionView()

    self:requestNetwork(true, function(success, _)
        if success then
            if self.dataList:size() > 0 then
                self.collectionView:reloadData()
            end
        end
    end)
    return self.containerView
end

---优先加载其他辅助文件
---@private
function _class:loadExtensions()
    require("../common/Constant")
end

---@private
function _class:setupTabar()
   
    local toolbar = LinearLayout(LinearType.HORIZONTAL)
                            :width(MeasurementType.MATCH_PARENT)
                            :height(40)
                            
    local toolbarView = require('../common/ToolBar')
    toolbar:addView(toolbarView:setupToolbar())
    self.containerView:addView(toolbar)
end

---创建collectionView
---@private
function _class:setupCollectionView()
    self.headerViewHeight = 95

    self.collectionView = WaterfallView(false, true):width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
    self.collectionView:useAllSpanForLoading(true)
    self.collectionView:showScrollIndicator(true)
    self.collectionView:marginLeft(20):marginRight(20)
    self.containerView:addView(self.collectionView)

    self.layout = WaterfallLayout()
    self.layout:lineSpacing(4):spanCount(1)
    self.collectionView:layout(self.layout)

    self.collectionView:setLoadingCallback(function ()

        self:requestNetwork(false, function(success, data)
            self.collectionView:stopLoading()
            if not data or data:size() == 0 then
                self.collectionView:noMoreData()
            else
                if success then
                    self.collectionView:reloadData()
                end
            end
            
        end)
    end)

    self:setupCollectionViewAdapter()
end

--- @private
function _class:setupCollectionViewAdapter()
    local cellIntroReuseId = 'introCell'

    local adapter = WaterfallAdapter()
    self.adapter = adapter

    adapter:headerValid(function(_)
        return true
    end)

    adapter:heightForHeader(function(_)
        return self.headerViewHeight
    end)

    adapter:initHeader(function(header)
        header.contentView:removeAllSubviews()
        header.contentView:addView(self:headerView())
    end)

    adapter:fillHeaderData(function(_, _, _)
        --do nothing
    end)

    self.adapter:sectionCount(function()
        return 1
    end)

    adapter:rowCount(function(_)
        return self.dataList:size()
    end)

    adapter:reuseId(function(section, row)
        return cellIntroReuseId
    end)

    adapter:initCellByReuseId(cellIntroReuseId, function(cell)
        local internalCell = require("../intro/IntroCell"):new()
        internalCell:setupCellSubviews()
        cell._cell = internalCell

        cell.contentView:bgColor(ColorConstants.IntroCellBackColor)
        cell.contentView:cornerRadius(2)
        cell.contentView:addView(internalCell.containerView)
    end)

    self.adapter:fillCellDataByReuseId(cellIntroReuseId, function(cell, section, position)
        --填充数据
        cell._cell:updateCell(self.dataList:get(position))
    end)

    adapter:heightForCell(function(_, position)
        return 92
    end)

    adapter:selectedRowByReuseId(cellIntroReuseId, function(cell, _, row)
       
        local params = Map()
        params:put('ticket',self.ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('loadWebUrl',self.dataList:get(row):get('article_detail_url'))
        params:put('article_id',self.dataList:get(row):get('article_id'))
        Navigator:gotoPageOri(NavigatorRoute.IntroDetailViewRoute,params, 3,AnimType.BottomToTop)
    end)

    self.collectionView:adapter(adapter)
end

---创建headerView
---@private
function _class:headerView()
    self.headerView = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT):height(self.headerViewHeight)
                        :bgColor(ColorConstants.IntroCellBackColor):cornerRadius(2)
    local userContainer = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT):height(self.headerViewHeight - 6)
    local lineImage = ImageView():width(MeasurementType.MATCH_PARENT):height(6):contentMode(ContentMode.SCALE_TO_FILL)
                        :image(_ImageRootRoute .. 'images/image_master_user_line.png')

    self.avatarImage = ImageView():width(73):height(73):marginLeft(10):marginTop(10):marginRight(10):cornerRadius(3):contentMode(ContentMode.SCALE_ASPECT_FILL)
    local rightContainer = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):marginTop(10)
    self.nickNameLabel = Label():fontSize(12):textColor(Color(219,188,138,1))
    self.serviceLabel = Label():fontSize(10):textColor(Color(123,123,123,1)):marginTop(5)
    self.descLabel = Label():fontSize(10):textColor(Color(123,123,123,1)):marginTop(20)

    rightContainer:addView(self.nickNameLabel):addView(self.serviceLabel):addView(self.descLabel)

    userContainer:addView(self.avatarImage):addView(rightContainer)

    self.headerView:addView(userContainer):addView(lineImage)
    return self.headerView
end

---请求接口
---@private
function _class:requestNetwork(first, complete)
    
    local http = Http()

    local header = {}
    header['Ticket'] = self.ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['game_id'] = self.game_id
    params['god_article_id'] = self.user_id
    params['page'] = self.pageIndex
    params['page_size'] = '10'

    http:post(HttpContants.Root .. HttpContants.Http_Master_User,params,header,function(success, resp, error)
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data')
                local list = data:get('article'):get('list')
                local user = data:get('god')
                if first then
                    if user then
                        self.avatarImage:image(user:get('god_avatar'))
                        self.nickNameLabel:text(user:get('god_nickname'))
                        self.serviceLabel:text(user:get('god_server'))
                        self.descLabel:text(user:get('summary'))
                    end
                    
                    if list then
                        self.dataList = list
                    end
                elseif list then
                    self.dataList:addAll(list)
                end
                complete(true, list)
                self.pageIndex = self.pageIndex + 1
            else
            end
        end
    end)

end

local ticket = window:getExtra():get('ticket')
local gameid = window:getExtra():get('gameid')
local user_id = window:getExtra():get('user_id')
local role_id = window:getExtra():get('role_id')
_class:new(ticket,gameid,user_id,role_id)
window:addView(_class:rootView())

return _class