---
--- Generated by lvmm
--- DateTime: 2020-08-06
--- 大神页面
---

local _class = {
    _name = 'MasterPagerView',
    _version = '1.0',
}

---@public
function _class:new(Ticket,game_id,role_id)
    local o = {}
    setmetatable(o, {__index = self})
    self.Ticket = Ticket
    self.game_id = game_id
    self.role_id = role_id
    self.dataList = Array()
    self.recommendUserList = Array()
    self.bannerList = Array()
    self.pageIndex = 1
    return o
end

---@public
---@return View containerView
function _class:rootView()
    if self.containerView then
        return self.containerView
    end
    self.containerView = LinearLayout(LinearType.VERTICAL):marginTop(10)
    self.containerView:width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):marginLeft(10):marginRight(10)
    self:createSubviews()
    return self.containerView
end

---创建子视图
---@private
function _class:createSubviews()
    self:setupCollectionView()
    self:requestNetwork(function(success, _)
        if success then
            if self.dataList:size() > 0 then
                self.collectionView:reloadData()
            end
        end
    end)
end
---创建collectionView
---@private
function _class:setupCollectionView()
    self.headerViewHeight = 130

    self.collectionView = WaterfallView(false, true):width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
    self.collectionView:useAllSpanForLoading(true)
    self.collectionView:showScrollIndicator(true)
    self.containerView:addView(self.collectionView)

    self.layout = WaterfallLayout()
    --self.layout:lineSpacing(30)
    self.layout:lineSpacing(4):spanCount(1)
    self.collectionView:layout(self.layout)

    self.collectionView:setLoadingCallback(function ()
        self:requestNetworkMore(function(success, data)
            self.collectionView:stopLoading()
            
            if not data or data:size() == 0 then
                self.collectionView:noMoreData()
            else
                if success then
                    self.collectionView:reloadData()
                end
            end
            
        end)
    end)

    self:setupCollectionViewAdapter()
end

--- @private
function _class:setupCollectionViewAdapter()
    local cellIntroReuseId = 'introCell'
    local cellMasterReuseId = 'masterCell'
    local cellTitleReuseId = 'titleCell'

    local adapter = WaterfallAdapter()
    self.adapter = adapter

    adapter:headerValid(function(_)
        return true
    end)

    adapter:heightForHeader(function(_)
        return self.headerViewHeight
    end)

    adapter:initHeader(function(header)
        header.contentView:removeAllSubviews()
        header.contentView:addView(self:headerView())
    end)

    adapter:fillHeaderData(function(_, _, _)
        --do nothing
    end)

    adapter:sectionCount(function()
        return 1
    end)

    adapter:rowCount(function(_)
        return self.dataList:size()
    end)

    adapter:reuseId(function(section, row)
        if(self.dataList:get(row):get('type') == 1) then
            return cellIntroReuseId
        elseif self.dataList:get(row):get('type') == 2 then
            return cellMasterReuseId
        elseif self.dataList:get(row):get('type') == 3 then
            return cellTitleReuseId
        else
            return cellIntroReuseId
        end
    end)

    adapter:initCellByReuseId(cellTitleReuseId, function(cell)
        cell.titleView = Label():textColor(Color(222,197,158,1)):text('大神专栏'):weight(1):marginTop(10)
        cell.contentView:addView(cell.titleView)
    end)

    adapter:initCellByReuseId(cellIntroReuseId, function(cell)
        local internalCell = require("intro/IntroCell"):new()
        internalCell:setupCellSubviews()
        cell._cell = internalCell

        cell.contentView:bgColor(ColorConstants.IntroCellBackColor)
        cell.contentView:cornerRadius(2)
        cell.contentView:addView(internalCell.containerView)
    end)

    adapter:initCellByReuseId(cellMasterReuseId, function(cell)
        local internalCell = require("master/masterCell"):new()
        internalCell:setupCellSubviews()
        cell._cell = internalCell

        cell.contentView:bgColor(ColorConstants.IntroCellBackColor)
        cell.contentView:cornerRadius(2)
        cell.contentView:addView(internalCell.containerView)
    end)

    adapter:fillCellDataByReuseId(cellIntroReuseId, function(cell, section, position)
        --填充数据
        cell._cell:updateCell(self.dataList:get(position))
    end)

    adapter:fillCellDataByReuseId(cellMasterReuseId, function(cell, section, position)
        --填充数据
        cell._cell:updateCell(self.dataList:get(position),function (type)
            
        end)
    end)

    adapter:heightForCell(function(_, position)
        if(self.dataList:get(position):get('type') == 3) then
            return 30
        else 
            if self.dataList:get(position):get('type') == 1 then
                return 92
            else
                return 88
            end
        end
        
    end)

    adapter:selectedRowByReuseId(cellMasterReuseId, function(cell, _, row)
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('user_id',self.dataList:get(row):get('god_article_id'))
        Navigator:gotoPageOri(NavigatorRoute.MasterDetailViewRoute,params,3, AnimType.BottomToTop)
        
        -- if cell._cell.buttom then
            
        --     local filepath = 'MasterDetailView.lua'
        --     if System:Android() then
        --         filepath = 'assets://yz_super_lua/Module/social-lua/' .. filepath
        --     else
        --         filepath =  filepath
        --     end
        --     local params = Map()
        --     params:put('ticket',self.Ticket)
        --     params:put('gameid',self.game_id)
        --     params:put('user_id',self.dataList:get(row):get('god_article_id'))
        --     Navigator:gotoPage(filepath,params, AnimType.RightToLeft)

        -- elseif cell._cell.bottomContainer then
        --     local filepath = 'IntroDetailView.lua'
        --     if System:Android() then
        --         filepath = 'assets://yz_super_lua/Module/social-lua/' .. filepath
        --     else
        --         filepath =  filepath
        --     end
        --     local params = Map()
        --     params:put('ticket',self.Ticket)
        --     params:put('gameid',self.game_id)
        --     params:put('loadWebUrl',self.dataList:get(row):get('article_detail_url'))
        --     params:put('article_id',self.dataList:get(row):get('article_id'))
        --     Navigator:gotoPage(filepath,params, AnimType.RightToLeft)
        -- end
        
    end)

    adapter:selectedRowByReuseId(cellIntroReuseId, function(cell, _, row)
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('loadWebUrl',self.dataList:get(row):get('article_detail_url'))
        params:put('article_id',self.dataList:get(row):get('article_id'))
        Navigator:gotoPageOri(NavigatorRoute.IntroDetailViewRoute,params, 3,AnimType.BottomToTop)
    end)


    self.collectionView:adapter(adapter)
end

---创建headerView
---@private
function _class:headerView()
    self.headerView = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT):height(self.headerViewHeight)

    self.bannerContainer = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT):height(self.headerViewHeight - 30)
    self.titleContainer = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT):height(30)

    --banner
    self.bannerView = ViewPager():width(320):height(MeasurementType.MATCH_PARENT)
    self.bannerView:setPageClickListener(function (position)
        local params = Map()
        params:put('loadWebUrl',self.bannerList:get(position):get('url'))
        Navigator:gotoPageOri(NavigatorRoute.WebViewRoute,params, 3,AnimType.BottomToTop)
    end)
    self.bannerAdapter = ViewPagerAdapter()
    self.bannerAdapter:getCount(function ()  --设置cell数量回调
        return self.bannerList:size()
    end)
    self.bannerAdapter:initCell(function (cell_1, position)  --设置初始化cell的回调
            cell_1.bannerImage = ImageView():width(320):height(MeasurementType.MATCH_PARENT)
            cell_1.bannerImage:contentMode(ContentMode.SCALE_ASPECT_FILL)
            cell_1.contentView:cornerRadius(3):clipToBounds(true)  --设置圆角
            cell_1.contentView:addView(cell_1.bannerImage)
        end)
    self.bannerAdapter:fillCellData(function (cell_1, position)  --设置初始化cell数据的回调
            cell_1.bannerImage:image(self.bannerList:get(position):get('cover_img'))
        end)
    self.bannerView:autoScroll(true)  --是否自动滚动
    self.bannerView:frameInterval(2.5)  --播放的默认周期
    self.bannerView:recurrence(true)  --是否循环滚动
    self.bannerView:showIndicator(true)  --是否显示滚动指示器
    self.bannerView:adapter(self.bannerAdapter)

    --大神推荐
    local introRootContainer = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT):height(self.headerViewHeight - 30)
  
    local introLabel = Label():text("大神推荐"):marginLeft(16):textColor(Color(222,197,158,1))
    local introtjContainer = View():width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT)
    local introLeftImage = ImageView():width(23):height(37):image(_ImageRootRoute .. 'images/image_recommd_left.png'):setGravity(Gravity.LEFT):marginTop(16):marginLeft(5)
    local introRightImage = ImageView():width(23):height(37):image(_ImageRootRoute .. 'images/image_recommd_right.png'):setGravity(Gravity.RIGHT):marginTop(16):marginRight(5)
    local introBackground = ImageView():width(MeasurementType.MATCH_PARENT):height(27):marginTop(20):image(_ImageRootRoute .. 'images/image_recommd_background.png'):contentMode(ContentMode.SCALE_TO_FILL)
    self:setupIntroUserListView():setGravity(Gravity.CENTER):marginLeft(32):marginRight(32):marginTop(3)
    
    introtjContainer:addView(introLeftImage):addView(introRightImage):addView(introBackground):addView(self.tapTableView)
    
    introRootContainer:addView(introLabel):addView(introtjContainer)
    self.bannerContainer:addView(self.bannerView):addView(introRootContainer)

    --大神推荐
    local titleLabel = Label():textColor(Color(222,197,158,1)):text('大神专访'):weight(1):marginTop(10)
    local changeContainer = LinearLayout(LinearType.HORIZONTAL):marginTop(10)
    local changeIcon = ImageView():width(12):height(12):image(_ImageRootRoute .. 'images/ic_ds_change.png'):marginLeft(3)
    local chageLabel = Label():text('换一换'):textColor(Color(160,102,25,1)):fontSize(10)
    changeIcon:onClick(function()
        self:requestChange()
    end)
    chageLabel:onClick(function()
        self:requestChange()
    end)

    changeContainer:addView(chageLabel):addView(changeIcon)

    self.titleContainer:addView(titleLabel):addView(changeContainer)
    self.headerView:addView(self.bannerContainer):addView(self.titleContainer)
    return self.headerView
end

function _class:setupIntroUserListView()
    self.tapTableView = CollectionView(false, false):width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):scrollDirection(ScrollDirection.HORIZONTAL)
    self.tapLayout = CollectionViewGridLayout():itemSpacing(25):spanCount(1)
    self.tapAdapter = CollectionViewAutoFitAdapter()
    self.tapAdapter:initCell(function(cell)
        cell.rootContainer = LinearLayout(LinearType.VERTICAL):width(57)
        cell.avatarContainer = View():width(57):height(57):bgImage(_ImageRootRoute .. 'images/image_recommd_avatar_background.png')
        cell.avatarImage = ImageView():width(50):height(50):setGravity(Gravity.CENTER):cornerRadius(25):contentMode(ContentMode.SCALE_ASPECT_FILL)
        cell.avatarContainer:addView(cell.avatarImage)
        cell.tapLabel = Label():textColor(Color(177,162,138,1))
                               :fontSize(10)
                               :bgColor(Color(92,74,59,0.7))
                               :padding(3,4,3,3)
                               :cornerRadius(5)
                               :borderWidth(1)
                               :marginTop(4)
                               :borderColor(Color(66,66,66,1))
                               :setGravity(Gravity.CENTER)
        cell.rootContainer:addView(cell.avatarContainer):addView(cell.tapLabel)
        cell.contentView:addView(cell.rootContainer)
    end)

    self.tapAdapter:fillCellData(function(cell, _, row)
        local item = self.recommendUserList:get(row)
        cell.avatarImage:image(item:get('article_addition'):get('god_avatar'):get('content'))
        cell.tapLabel:text(item:get('article_addition'):get('god_nickname'):get('content'))
    end)

    self.tapAdapter:rowCount(function()
        return self.recommendUserList:size()
    end)

    self.tapAdapter:selectedRow(function(cell, _, row)
       
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('user_id',self.recommendUserList:get(row):get('id'))
        Navigator:gotoPageOri(NavigatorRoute.MasterDetailViewRoute,params, 3,AnimType.BottomToTop)
    end)

    self.tapTableView:layout(self.tapLayout)
    
    return self.tapTableView
end

---请求接口
---@private
function _class:requestNetwork(complete)
    local http = Http()

    local header = {}
    header['Ticket'] = self.Ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['game_id'] = self.game_id
    params['page_size'] = '10'
    

    http:post(HttpContants.Root .. HttpContants.Http_Master_Module,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data')
                self.recommendUserList = data:get('god_recommend')
                self.bannerList = data:get('god_ad')
                self.tapTableView:adapter(self.tapAdapter)
                self.bannerView:reloadData()
                
                local introList = data:get('god_interview'):get('list')
                for i = 1, introList:size() do
                    introList:get(i):put('type',1)
                    self.dataList:add(introList:get(i))
                end

                --title
                local title = Map()
                title:put('type',3)
                self.dataList:add(title)

                --专访
                local masterList = data:get('god_column')
                for i = 1, masterList:size() do
                    masterList:get(i):put('type',2)
                    self.dataList:add(masterList:get(i))
                end
                complete(true,data)
                self.pageIndex = self.pageIndex + 1
            else
            end
        else
          
        end
        _class.isRequesting = false
    end)
end

---加载更多专栏
---@private
function _class:requestNetworkMore(complete)
    local http = Http()

    local header = {}
    header['Ticket'] = self.Ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['game_id'] = self.game_id
    params['page_size'] = '10'
    params['page'] = self.pageIndex

    http:post(HttpContants.Root .. HttpContants.Http_Master_Module_List,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data'):get('list')
                --专访
                if data then
                    for i = 1, data:size() do
                        data:get(i):put('type',2)
                        self.dataList:add(data:get(i))
                    end
                end
                complete(true,data)
                self.pageIndex = self.pageIndex + 1
            else
            end
        else
          
        end
        _class.isRequesting = false
    end)
end

---换一换
---@private
function _class:requestChange()
    local http = Http()

    local header = {}
    header['Ticket'] = self.Ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['game_id'] = self.game_id

    http:post(HttpContants.Root .. HttpContants.Http_Master_Change,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local data = resp:get('data')
                --专访
                if data then
                    if data:size() == 1 then
                        self.dataList:replace(1,data:get(1))
                    else
                        self.dataList:replace(1,data:get(1))
                        self.dataList:replace(2,data:get(2))
                    end
                    self.collectionView:reloadData()
                end
            else
            end
        else
          
        end
        _class.isRequesting = false
    end)
end

return _class