---
--- Generated by lvmm
--- DateTime: 2020-09-09
--- 我点赞-列表
---

local _class = {
    _name = 'MineLikeRecordView',
    _version = '1.0',
    isRequesting = false
}

---@public
--- like_type :点赞类型  1、文章 2、图片 3、视频
function _class:new(Ticket,game_id,role_id,like_type)
    local o = {}
    setmetatable(o, {__index = self})
    self.dataList = Array()
    self.pageIndex = 1
    self.role_id = role_id
    self.Ticket = Ticket
    self.game_id = game_id
    self.like_type = like_type
    return o
end

---@public
---@return View containerView
function _class:rootView(like_type)
    self.like_type = like_type
    if self.containerView then
        return self.containerView
    end
    self.containerView = View():width(MeasurementType.MATCH_PARENT)
                            :height(MeasurementType.MATCH_PARENT)
                            :marginLeft(20)
                            :marginRight(20)
    -- self.containerView:bgColor(ColorConstants.IntroToolBarTitlleNormal)
 
    self:initListView()
    self:initEmptyView()
    self:setupDataSource(true)
    return self.containerView
end

--绘制空icon
function _class:initEmptyView()
    -- body
    self.emptyImage = ImageView():width(200):height(200):image(_ImageRootRoute .. "images/img_mine_like_empty.png")
                            :setGravity(Gravity.CENTER):gone(true)
    self.containerView:addView(self.emptyImage)
end

--绘制列表控件
function _class:initListView()
    self.collectionView = WaterfallView(false, true)
                                :width(MeasurementType.MATCH_PARENT)
                                :height(MeasurementType.MATCH_PARENT)
                                :scrollDirection(ScrollDirection.VERTICAL)--竖直方向滑动
                                --:scrollDirection(ScrollDirection.HORIZONTAL)--水平方向滑动
                                :showScrollIndicator(true)--是否显示滑动指示器

    --layout
    local collectionLayout = WaterfallLayout()
    collectionLayout:lineSpacing(5)
    collectionLayout:itemSpacing(5)
    --竖直滑动代表显示列数；水平滑动代表显示行数
    if self.like_type == 1 then
        collectionLayout:spanCount(1)
    else
        collectionLayout:spanCount(3)
    end

    --设置layout
    self.collectionView:layout(collectionLayout)

    self.collectionView:setLoadingCallback(function ()
        self:requestNetwork(false,function(success, data)
            self.collectionView:stopLoading()
            
            if not data or data:size() == 0 then
                self.collectionView:noMoreData()
            else
                if success then
                    self.collectionView:reloadData()
                end
            end
        end)
    end)

    --adapter
    self.adapter = WaterfallAdapter()

    self.adapter:sectionCount(function()
        return 1
    end)

    -----------------------------设置子view个数---------------------------------------
    self.adapter:rowCount(function(section)
        return self.dataList:size()
    end)
    ------------------------------设置cell宽高----------------------------------------
    --根据类型标识设置对应子view的宽高
    self.adapter:heightForCell(function(_, row)
        if self.like_type == 3 then
            return 170
        elseif self.like_type == 1 then
            return 92
        elseif self.like_type == 2 then
            return 130
        end
    end)
    -------------------------------子view类型-----------------------------------------
    --返回当前位置子view的类型标识
    self.adapter:reuseId(function(section, row)
        return "CellId"
    end)
    -------------------------------创建子view-----------------------------------------
    self.adapter:initCellByReuseId("CellId", function(cell)
        if self.like_type == 1 then
            local internalCell = require("../intro/IntroCell"):new()
            internalCell:setupCellSubviews()
            cell._cell = internalCell

            cell.contentView:bgColor(ColorConstants.IntroCellBackColor)
            cell.contentView:cornerRadius(2)
            cell.contentView:addView(internalCell.containerView)
        else
            local internalCell = require("../amway/AmwayCell"):new()
            internalCell:setupCellSubviews(self.like_type == 3)
            cell._cell = internalCell

            cell.contentView:addView(internalCell.containerView)
        end
        
    end)
    local cid = ''
    if(self.like_type == 3) then
        cid = 'sdk_amway_video'
    else
        cid = ''
    end
    --------------------------将子view与数据进行绑定赋值----------------------------------
    self.adapter:fillCellDataByReuseId("CellId", function(cell, section, row)
        --填充数据
        if self.like_type == 1 then
            cell._cell:updateCell(self.dataList:get(row))
        else
            cell._cell:updateCell(cid,self.dataList:get(row))
        end
        
    end)
    self.adapter:selectedRowByReuseId('CellId', function(cell, _, row)
      
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        params:put('article_id',self.dataList:get(row):get('article_id'))
        if self.like_type == 3 then
            params:put('loadWebUrl',self.dataList:get(row):get('video_detail'))
            params:put('cid','sdk_amway_video')
            Navigator:gotoPageOri(NavigatorRoute.AmwayImageDetailRoute,params,3, AnimType.BottomToTop)
        elseif self.like_type == 2 then
            if self.dataList:get(row):get('cid') == 'sdk_amway_diffuse' then
                params:put('cid',self.dataList:get(row):get('cid'))
                params:put('loadWebUrl',self.dataList:get(row):get('content_img'))
                Navigator:gotoPageOri(NavigatorRoute.AmwayImageDetailRoute,params,1, AnimType.BottomToTop)
            else
                params:put('cid',self.dataList:get(row):get('cid'))
                params:put('loadWebUrl',self.dataList:get(row):get('content_img'))
                Navigator:gotoPageOri(NavigatorRoute.AmwayImageDetailRoute,params,3, AnimType.BottomToTop)
            end
            
        else
            params:put('loadWebUrl',self.dataList:get(row):get('article_detail_url'))
            Navigator:gotoPageOri(NavigatorRoute.IntroDetailViewRoute,params,3, AnimType.BottomToTop)
        end
    end)

    self.collectionView:adapter(self.adapter)
    
    self.containerView:addView(self.collectionView)

end

---请求接口
---@private
function _class:requestNetwork(first, complete)
    
    if not _class.isRequesting then

        _class.isRequesting = true

        local http = Http()

        local header = {}
        header['Ticket'] = self.Ticket
        header['gameid'] = self.game_id
        header['roleid'] = self.role_id

        local params = {}
        params['game_id'] = self.game_id
        params['type'] = self.like_type
        params['page'] = self.pageIndex
        params['page_size'] = '10'

        http:post(HttpContants.Root .. HttpContants.Http_Mine_Like_Record,params,header,function(success, resp, error)
        
            if success and resp then
                if(resp:get('code') == 0) then
                    local data = resp:get('data'):get('data')
                    if first then
                        self.dataList = data
                    elseif data then
                        self.dataList:addAll(data)
                    end
                    complete(true, data)
                    self.pageIndex = self.pageIndex + 1
                else
                end
            else
          
            end
            _class.isRequesting = false
        end)
    end 

end

--加载数据
function _class:setupDataSource(isFirst)
    self:requestNetwork(isFirst, function(success, _)
        if success then
            if self.dataList:size() > 0 then
                self.collectionView:reloadData()
            else
                self.emptyImage:gone(false)
            end
        end
    end)
end

return _class