---
--- Generated by lvmm
--- DateTime: 2020-08-26
--- 我的页面
---

local _class = {
    _name = 'MinePagerView',
    _version = '1.0',
}

---@public
function _class:new(Ticket,game_id,role_id,role_name,role_level,role_avatar)
    local o = {}
    setmetatable(o, {__index = self})
    self.Ticket = Ticket
    self.game_id = game_id
    self.role_id = role_id
    self.role_name = role_name
    self.role_level = role_level
    self.role_avatar = role_avatar
    return o
end

---@public
---@return View containerView

function _class:rootView()
    if self.containerView then
        return self.containerView
    end
    self.containerView = LinearLayout(LinearType.VERTICAL)
    self.containerView:width(MeasurementType.MATCH_PARENT):height(MeasurementType.MATCH_PARENT):marginLeft(10):marginRight(10)
    self:build()
    self:loadLikeNum()
    return self.containerView
end

function _class:build()

    if System:Android() then
        self.role_avatar = 'https://cdn-zs-studio.uuzuonline.com/product-374/cdn1/qa/advertise/avatar/10041.png'
    end

    local titleLabel = Label():height(40):text('我的'):fontSize(16):textColor(Color(219,188,138,1)):setGravity(Gravity.CENTER)
    self.containerView:addView(titleLabel)

    local mContainer = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT):height(80)
    self.mAvatarImg = ImageView():width(84):height(84):cornerRadius(3)
                            :image(self.role_avatar)
                            
    local mLevel = '等级: ' .. tostring(self.role_level)
    local rightContianer = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT):marginLeft(10)
    self.mPlayNameLabel = Label():text(self.role_name):fontSize(15):textColor(Color(219,188,138,1))
    self.mPlayLevelLabel = Label():text(mLevel):fontSize(14):textColor(Color(123,123,123,1)):marginTop(40)
    rightContianer:addView(self.mPlayNameLabel):addView(self.mPlayLevelLabel)
    mContainer:addView(self.mAvatarImg):addView(rightContianer)
    
    local lineImage = ImageView():width(MeasurementType.MATCH_PARENT):height(2):marginTop(20)
                            :contentMode(ContentMode.SCALE_TO_FILL):image(_ImageRootRoute .. 'images/image_master_user_line.png')
    
    local likeContainer = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT):height(50)

    local likeLableTitle = Label():text('我赞过的'):fontSize(15):textColor(Color(219,188,138,1)):weight(1):setGravity(Gravity.CENTER)
    self.likeLabelNumber = Label():text('-'):fontSize(15):textColor(Color(219,188,138,1)):setGravity(Gravity.CENTER)

    likeContainer:addView(likeLableTitle):addView(self.likeLabelNumber)

    local line = View():width(MeasurementType.MATCH_PARENT):height(0.5):bgColor(Color(66,66,66,1))

    self.containerView:addView(mContainer):addView(lineImage):addView(likeContainer):addView(line)

    likeContainer:onClick(function ()
        -- body
        local params = Map()
        params:put('ticket',self.Ticket)
        params:put('gameid',self.game_id)
        params:put('role_id',self.role_id)
        Navigator:gotoPageOri(NavigatorRoute.MineLikeDetailRoute,params,3, AnimType.BottomToTop)
    end)
end

--获取安利配置信息
function _class:loadLikeNum(complete)
    local http = Http()

    local header = {}
    header['Ticket'] = self.Ticket
    header['gameid'] = self.game_id
    header['roleid'] = self.role_id

    local params = {}
    params['game_id'] = self.game_id

    http:get(HttpContants.Root .. HttpContants.Http_Mine_Like,params,header,function(success, resp, error)
        
        if success and resp then
            if(resp:get('code') == 0) then
                local likeNum = resp:get('data'):get('num')
                self.likeLabelNumber:text(likeNum)
            else
            end
        else
        end
    end)

end

return _class