---
--- Generated by lvmm
--- DateTime: 2020-08-06
---

local _class = {
    _name = 'MineRecordToolBar',
    _version = '1.0'
}

---@public
function _class:new()
    local o = {}
    setmetatable(o, { __index = self })
    return o
end

---@public
function _class:setupItems(titles,callback)
    self.clickCallback = callback
    self:createBarButtonItems(titles)
end

---@private
function _class:createBarButtonItems(titles)
   
    local itemCount = titles:size()

    local tabToolBarHeight = 25

    self.contentView = LinearLayout(LinearType.VERTICAL):width(MeasurementType.MATCH_PARENT)
                            :height(35):priority(1):marginLeft(20):marginRight(20)
    
    self.tabToolBar = LinearLayout(LinearType.HORIZONTAL):width(MeasurementType.MATCH_PARENT):height(tabToolBarHeight)

    for i = 1, itemCount do
        local itemView = Label()
                            :width(60)
                            :height(25)
                            :marginTop(2)
                            :marginBottom(2)
                            :marginLeft(2)
                            :marginRight(2)
                            :cornerRadius(12)
                            :textColor(Color(177,162,138,1))
                            :setGravity(Gravity.CENTER)
                            :textAlign(TextAlign.CENTER)

        -- image
        itemView:onClick(function()
            self:updateBarItemImages(itemView,i)
            self.clickCallback(i)
        end)
        if i == 1 then
            self.preIndex = 1
            self.preItemView = itemView
            itemView:bgColor(Color(41,38,44,1))
        else
            itemView:bgColor(Color(41,38,44,0))
        end
        itemView:text(titles:get(i))
        self.tabToolBar:addView(itemView)
    end

    local lineImage = ImageView():width(MeasurementType.MATCH_PARENT):height(2):marginTop(4)
                                :contentMode(ContentMode.SCALE_TO_FILL):image(_ImageRootRoute .. 'images/image_master_user_line.png')

    self.contentView:addView(self.tabToolBar):addView(lineImage)
end

function _class:updateBarItemImages(itemView, index)
    if index == self.preIndex then
        return --点击同一个barItem不更新image
    end
    self.preItemView:bgColor(Color(41,38,44,0))
    itemView:bgColor(Color(41,38,44,1))

    self.preItemView = itemView
    self.preIndex = index
end

return _class